// The entire file can be run from the shell with
//     magma LinkComplementHelpers.m LinkComplement15.m
// or from within magma with
//     load "LinkComplementHelpers.m";
//     load "LinkComplement15.m";
// 

Bianchi15<a,c,t,u> := Group<a,c,t,u|(t,u),(a,c),a^2,(t*a)^3,
                                    u*c*u*a*t*u^-1*c^-1*u^-1*a*t^-1>;
Bianchi15P := [[t, u], [u*c*a, c^-1*a*u^-1*c^-1*u^-1*t*a]];

print "";
print "<2, (1+sqrt(-15))/2>";

VerifyLink(
    Bianchi15, Bianchi15P,
    [[2,0,1],[1,0,2]], 6,
    Expand([Id(Bianchi15), t*a, (t*a)^2],
           [ [ [ 1, 0], [ 0, 1], [ 0, 1] ],
             [ [ 1, 0], [ 1, 0], [ 0, 1] ] ]));

print "";
print "<3, (3+sqrt(-15))/2>";

h:=a*t*a*t^-1*a;

VerifyLink(
    Bianchi15, Bianchi15P,
    [[3,1,1],[3,0,1]], 12,
    Expand([Id(Bianchi15), a, h, h*a],
           [ [ [-1, 1], [ 0, 1], [-1, 1], [ 0, 1] ],
             [ [ 1, 1], [ 0, 1], [ 0, 1], [ 0, 1] ] ]));

print "";
print "<(1+sqrt(-15))/2>";

VerifyLink(
    Bianchi15, Bianchi15P,
    [[4,0,1],[1,0,4]], 24,
    Symmetrize(
        a*t^2*a, 2,
        [[ <(t*a)^-1,       [ 1, 1]>,
           <t^2*(t*a)^-1,   [ 0, 1]> ],
         [ <Id(Bianchi15),  [ 1, 0]>,
           <t^2,            [ 1, 0]> ]],
        [[ <Id(Bianchi15),  [ 1, 1]>,
           <t*a,            [ 1, 1]> ],
         [ <t*a,            [ 1, 0]>,
           <(t*a)^-1,       [ 1, 0]> ]]));

print "";
print "<5, (5+sqrt(-15))/2>";

b:=(t*a*u*a*u^-1*a^-1*t^-1);
r:=t*c*(t*a)*c^-1*t^-1;

VerifyLink(
    Bianchi15, Bianchi15P,
    [[5,2,1],[5,0,1]], 60,
    Expand(
        [ Id(Bianchi15),   a,   b,   a*b,
          r,               a*r, b*r, a*b*r,
          r^-1,            a*r^-1, b*r^-1, a*b*r^-1 ],
        [ [ [-1, 1], [ 0, 1], [ 0, 1], [ 0, 1],
            [ 0, 1], [ 0, 1], [ 0, 1], [ 0, 1], 
            [-1, 1], [-1, 1], [-1, 1], [-1, 1] ],
          [ [ 1, 0], [ 1, 1], [ 1, 1], [ 1, 1],
            [ 0, 1], [ 0, 1], [ 0, 1], [ 0, 1], 
            [ 0, 1], [ 0, 1], [ 0, 1], [ 0, 1]]]));

// Difference to arXiv version 1: fixed print showing conjugate ideal.

print "";
print "<(3-sqrt(-15))/2>";

r:=(t^2*a*t^-2*a); 
s:=(a*t^-2*a*t^2);

VerifyLink(
    Bianchi15, Bianchi15P,
    [[6,-2,1],[3,0,2]], 72,
    Expand(
        [ Id(Bianchi15), r, s, r*s,
            (t*a), r*(t*a), s*(t*a), r*s*(t*a),
            (t*a)^-1, r*(t*a)^-1, s*(t*a)^-1, r*s*(t*a)^-1 ],
        [ [ [ 0, 1], [ 0, 1], [ 0, 1], [ 0, 1], 
            [ 1, 1], [ 0, 1], [ 0, 1], [ 0, 1],
            [ 0, 1], [ 0, 1], [ 0, 1], [ 0, 1] ],
          [ [ 1, 1], [ 1, 1], [ 1, 1], [ 1, 1], 
            [ 1, 0], [ 1, 1], [ 1, 1], [ 1, 1],
            [ 1, 0], [ 1, 1], [ 1, 1], [ 1, 1] ] ]));
