// The entire file can be run from the shell with
//     magma LinkComplementHelpers.m LinkComplement31.m
// or from within magma with
//     load "LinkComplementHelpers.m";
//     load "LinkComplement31.m";
// 

Bianchi31<g1,g2,g3,g4,g5> := Group<g1,g2,g3,g4,g5|
    (g1,g3),(g2)^3,(g2*g1^-1)^2,(g5,g4),
    g4*g1^-1*g3^-1*g2*g3*g4^-1*g2*g4*g3^-1*g1^-1*g2*g3*g4^-1*g2,
    g5*g3^-1*g2*g3*g4^-1*g2*g1^-1*g5^-1*g2^-1*g4*g3^-1*g2^-1*g3*g1,
    g2*g3*g4^-1*g2*g1^-1*g4*g3^-1*g2*g3*g4^-1*g1*g2^-1*g4*g3^-1>;

Bianchi31P := [ [ g1, g3 ],
                [ g4, g5 ],
                [ g1*g5, g3^-1*g2*g3*g4^-1*g2*g5 ]];

print "";
print "<2, (1+sqrt(-31))/2>";

VerifyLink2(Bianchi31, Bianchi31P, [[0,1],[1,0],[1,0]], 6);

print "";
print "<4, (1+sqrt(-31))/2>";

VerifyLink(
    Bianchi31, Bianchi31P,
    [[4,0,1],[2,1,2],[1,0,4]],24,
    Symmetrize(
        g1^2, 2,
        [[ <Id(Bianchi31),   [ 0, 1]>,
           <g2^-1*g1^-2*g2,  [ 0, 1]> ],
         [ <Id(Bianchi31),   [ 0, 1]>,
           <g2^-1*g1^-2*g2,  [ 1, 0]> ],
         [ <g2^-1,           [ 1, 0]>,
           <g2^-1*g1^-2,     [ 1, 0]> ]],
        [[ <g2^-1,           [ 0, 1]>,
           <g2^-2,           [ 0, 1]> ],
         [ <g2^-1,           [ 0, 1]>,
           <g2^-2,           [ 0, 1]> ],
         [ <Id(Bianchi31),   [ 1, 0]>,
           <g2^-2,           [ 1, 0]> ]]));

print "";
print "<5, (3+sqrt(-31))/2>";

a:=g1*g2*g1^-2;
b:=g2*g5*g2*g1^-1*g5^-1*g2^-1;

VerifyLink(
    Bianchi31, Bianchi31P,
    [[5,-1,1],[5,1,1],[5,1,1]], 60,
    Expand(
        [ Id(Bianchi31), b,      a,      b*a,
          g2,            b*g2,   a*g2,   b*a*g2,
          g2^2,          b*g2^2, a*g2^2, b*a*g2^2 ],
        [ [ [ 1, 2], [ 1, 1], [ 0, 1], [ 0, 1],
            [ 0, 1], [ 0, 1], [ 0, 1], [ 1, 1],
            [ 0, 1], [ 0, 1], [ 0, 1], [ 0, 1] ],
          [ [ 0, 1], [ 0, 1], [ 0, 1], [ 0, 1],
            [ 0, 1], [ 0, 1], [ 0, 1], [ 0, 1],
            [ 0, 1], [ 0, 1], [ 0, 1], [ 0, 1] ],
          [ [-1, 2], [-1, 2], [-1, 2], [-1, 2],
            [-1, 2], [-1, 2], [-1, 2], [-1, 2],
            [-1, 2], [-1, 2], [-1, 2], [-1, 2] ] ]));
