// The entire file can be run from the shell with
//     magma LinkComplementHelpers.m LinkComplement7.m
// or from within magma with
//     load "LinkComplementHelpers.m";
//     load "LinkComplement7.m";
// 

// Bianchi group
Bianchi7<a,t,u> := Group<a,t,u|a^2,(t*a)^3,(a*t*u^-1*a*u)^2,(t,u)>;
// Parabolic elements fixing cusp of the Bianchi orbifold
Bianchi7P := [[ t, u ]];

print "";
print "<(1+sqrt(-7))/2>";
VerifyLink2(
    Bianchi7, Bianchi7P,
    [[0,1]], 6);

print "";
print "<(3+sqrt(-7))/2>";
VerifyLink(
    Bianchi7, Bianchi7P,
    [[4,1,1]], 24,
    [[ <Id(Bianchi7), [-1, 1]>,
       <a,            [ 0, 1]>,
       <t*a,          [ 0, 1]>,
       <t^-1*a,       [ 0, 1]>,
       <t^-2*a,       [ 0, 1]>,
       <a*t^-2*a,     [ 0, 1]>]]);

print "";
print "<2>";
VerifyLink(
    Bianchi7, Bianchi7P,
    [[2,0,2]], 36,
    [[ <Id(Bianchi7),    [ 1, 0]>,
       <a,               [ 0, 1]>,
       <t*a,             [ 0, 1]>,
       <u*a,             [ 0, 1]>,
       <t^-1*u*a,        [ 1, 0]>,
       <a*u*t^-1*a,      [ 1, 0]>,
       <a*u^-1*a,        [ 1, 0]>,
       <t^-1*a*u^-1*a,   [ 0, 1]>,
       <t^-1*a*u*t^-1*a, [ 0, 1]>]]);

print "";
print "<1+sqrt(-7)>";

VerifyLink(
    Bianchi7, Bianchi7P,
    [[4,0,2]], 144,
    Symmetrize(
        a*t^2*a, 2,
        [[<a,                 [-1, 1]>,
          <t^2*a,             [ 0, 1]>,
          <u*a,               [ 0, 1]>,
          <t^-2*u*a,          [ 0, 1]>,
          <t^-1*a*t^-1*u*a,   [ 0, 1]>,
          <t*a*t^-1*u*a,      [ 0, 1]>]],
        [[<Id(Bianchi7),      [ 0, 1]>,
          <t*a,               [ 0, 1]>,
          <t^-1*u*a,          [ 0, 1]>,
          <a*u*a,             [ 0, 1]>,
          <a*t^-1*u*a,        [ 0, 1]>,
          <a*t^-1*a*t^-1*u*a, [ 0, 1]>]]));

print "";
print "<sqrt(-7)>";

h:=a*u*a*u^-1*t^-1*a;

VerifyLink(
    Bianchi7, Bianchi7P,
    [[7,3,1]], 168,
    [[ <Id(Bianchi7), [-1, 1]>,
       <t^-3*a,       [ 0, 1]>,
       <t^-2*a,       [ 0, 1]>,
       <t^-1*a,       [ 0, 1]>,
       <a,            [ 0, 1]>,
       <t*a,          [ 0, 1]>,
       <t^2*a,        [ 0, 1]>,
       <t^3*a,        [ 0, 1]>,

       <h,            [ 0, 1]>,
       <t^-3*h*a,     [-1, 1]>,
       <t^-2*h*a,     [-1, 1]>,
       <t^-1*h*a,     [-1, 1]>,
       <h*a,          [-1, 1]>,
       <t*h*a,        [-1, 1]>,
       <t^2*h*a,      [-1, 1]>,
       <t^3*h*a,      [-1, 1]>,
       
       <h^2,          [ 0, 1]>, 
       <t^-3*h^2*a,   [-1, 1]>,
       <t^-2*h^2*a,   [-1, 1]>,
       <t^-1*h^2*a,   [-1, 1]>,
       <h^2*a,        [-1, 1]>,
       <t*h^2*a,      [-1, 1]>,
       <t^2*h^2*a,    [-1, 1]>,
       <t^3*h^2*a,    [-1, 1]>]]);

print "";
print "<(5+sqrt(-7))/2>";

VerifyLink(
    Bianchi7, Bianchi7P,
    [[8,2,1]], 192,
    Symmetrize(
        t*a, 3,
        [[ ]],
        [[ <Id(Bianchi7),   [ 0, 1]>,
           <t^-1*a,         [ 0, 1]>,
           <t^-2*a,         [ 0, 1]>,
           <t^-3*a,         [ 0, 1]>,
           <t^3*a,          [ 0, 1]>,
           <t^4*a,          [ 0, 1]>,
           <t^-1*a*t^2*a,   [ 0, 1]>,
           <t^3*a*t^3*a,    [-1, 2]>]]));

print "";
print "<2+sqrt(-7)>";

h:=a*u*a*t^-2*a;

VerifyLink(
    Bianchi7, Bianchi7P,
    [[11,5,-1]], 660,
    [[ <Id(Bianchi7), [-1, 2]>,
       <h,            [-1, 2]>,
       <h^2,          [-1, 2]>,
       <h^3,          [-1, 2]>,
       <h^4,          [-1, 2]>,
       
       <a,            [ 0, 1]>,
       <h*a,          [-1, 2]>,
       <h^2*a,        [-1, 2]>,
       <h^3*a,        [ 0, 1]>,
       <h^4*a,        [-1, 2]>,
       
       <t*a,          [ 0, 1]>,
       <h*t*a,        [-1, 2]>,
       <h^2*t*a,      [-1, 2]>,
       <h^3*t*a,      [-1, 2]>,
       <h^4*t*a,      [ 0, 1]>,


       <t^2*a,        [-1, 2]>,
       <h*t^2*a,      [-1, 2]>,
       <h^2*t^2*a,    [-1, 2]>,
       <h^3*t^2*a,    [-1, 2]>,
       <h^4*t^2*a,    [-1, 2]>,
       
       <t^3*a,        [-1, 3]>,
       <h*t^3*a,      [ 0, 1]>,
       <h^2*t^3*a,    [-1, 2]>,
       <h^3*t^3*a,    [-1, 2]>,
       <h^4*t^3*a,    [-1, 2]>,
       
       <t^4*a,        [ 0, 1]>,
       <h*t^4*a,      [ 0, 1]>,
       <h^2*t^4*a,    [ 0, 1]>,
       <h^3*t^4*a,    [ 0, 1]>,
       <h^4*t^4*a,    [ 0, 1]>,


       <t^5*a,        [-1, 2]>,
       <h*t^5*a,      [ 0, 1]>,
       <h^2*t^5*a,    [ 0, 1]>,
       <h^3*t^5*a,    [ 0, 1]>,
       <h^4*t^5*a,    [ 0, 1]>,

       <t^6*a,        [-1, 2]>,
       <h*t^6*a,      [ 0, 1]>,
       <h^2*t^6*a,    [-1, 2]>,
       <h^3*t^6*a,    [-1, 2]>,
       <h^4*t^6*a,    [ 0, 1]>,

       <t^7*a,        [ 0, 1]>,
       <h*t^7*a,      [ 0, 1]>,
       <h^2*t^7*a,    [ 0, 1]>,
       <h^3*t^7*a,    [ 0, 1]>,
       <h^4*t^7*a,    [ 0, 1]>,
       

       <t^8*a,        [-1, 2]>,
       <h*t^8*a,      [-1, 2]>,
       <h^2*t^8*a,    [ 0, 1]>,
       <h^3*t^8*a,    [-1, 3]>,
       <h^4*t^8*a,    [ 0, 1]>,

       <t^9*a,        [-1, 2]>,
       <h*t^9*a,      [ 0, 1]>,
       <h^2*t^9*a,    [-1, 2]>,
       <h^3*t^9*a,    [ 0, 1]>,
       <h^4*t^9*a,    [-1, 2]>,
       
       <t^10*a,       [-1, 3]>,
       <h*t^10*a,     [-1, 2]>,
       <h^2*t^10*a,   [-1, 2]>,
       <h^3*t^10*a,   [-1, 2]>,
       <h^4*t^10*a,   [-1, 2]>]]);

// Difference to arxiv version 1: replaced "-0" by "0"

print "";
print "<(7+sqrt(-7))/2>";

h:=a*t*u^-1*a*u*t^-2*a;
x:=t^-4*u*a*t^-1*u^2*a;

VerifyLink(
    Bianchi7, Bianchi7P,
    [[14,3,1]], 1008,
    [[ <Id(Bianchi7),     [-1, 4]>,
       <x,                [-1, 4]>,
       <x^-1,             [-1, 4]>,
       <h,                [-1, 3]>,
       <x*h,              [-1, 3]>,
       <x^-1*h,           [ 0, 1]>,
       
       <h^2,              [-1, 3]>,
       <x*h^2,            [-1, 3]>,
       <x^-1*h^2,         [-1, 3]>,
       <a,                [-1, 3]>,
       <x*a,              [-1, 4]>,
       <x^-1*a,           [ 0, 1]>,
       
       <t*a,              [-1, 3]>,
       <x*t*a,            [-1, 3]>,
       <x^-1*t*a,         [-1, 3]>,
       <t^-1*a,           [-1, 3]>,
       <x*t^-1*a,         [-1, 3]>,
       <x^-1*t^-1*a,      [ 0, 1]>,
       

       <t^2*a,            [-1, 3]>,
       <x*t^2*a,          [-1, 3]>,
       <x^-1*t^2*a,       [-1, 3]>,
       <t^-2*a,           [-1, 3]>,
       <x*t^-2*a,         [-1, 3]>,
       <x^-1*t^-2*a,      [-1, 3]>,
       
       <t^3*a,            [-1, 3]>,
       <x*t^3*a,          [-1, 3]>,
       <x^-1*t^3*a,       [-1, 3]>,
       <t^-3*a,           [-1, 3]>,
       <x*t^-3*a,         [-1, 3]>,
       <x^-1*t^-3*a,      [-1, 3]>,
       
       <h*a,              [ 0, 1]>,
       <x*h*a,            [ 0, 1]>,
       <x^-1*h*a,         [ 0, 1]>,
       <t*h*a,            [ 0, 1]>,
       <x*t*h*a,          [ 0, 1]>,
       <x^-1*t*h*a,       [ 0, 1]>,
       

       <t^-1*h*a,         [ 0, 1]>,
       <x*t^-1*h*a,       [ 0, 1]>,
       <x^-1*t^-1*h*a,    [ 0, 1]>,
       <t^2*h*a,          [ 0, 1]>,
       <x*t^2*h*a,        [ 0, 1]>,
       <x^-1*t^2*h*a,     [ 0, 1]>,
       
       <t^-2*h*a,         [ 0, 1]>,
       <x*t^-2*h*a,       [ 0, 1]>,
       <x^-1*t^-2*h*a,    [ 0, 1]>,
       <t^3*h*a,          [ 0, 1]>,
       <x*t^3*h*a,        [ 0, 1]>,
       <x^-1*t^3*h*a,     [ 0, 1]>,
       
       <t^-3*h*a,         [ 0, 1]>,
       <x*t^-3*h*a,       [ 0, 1]>,
       <x^-1*t^-3*h*a,    [ 0, 1]>,
       <h^2*a,            [ 0, 1]>,
       <x*h^2*a,          [ 0, 1]>,
       <x^-1*h^2*a,       [ 0, 1]>,

       
       <t*h^2*a,          [ 0, 1]>,
       <x*t*h^2*a,        [ 0, 1]>,
       <x^-1*t*h^2*a,     [ 0, 1]>,
       <t^-1*h^2*a,       [ 0, 1]>,
       <x*t^-1*h^2*a,     [ 0, 1]>,
       <x^-1*t^-1*h^2*a,  [ 0, 1]>,
       
       <t^2*h^2*a,        [ 0, 1]>,
       <x*t^2*h^2*a,      [ 0, 1]>,
       <x^-1*t^2*h^2*a,   [ 0, 1]>,
       <t^-2*h^2*a,       [ 0, 1]>,
       <x*t^-2*h^2*a,     [ 0, 1]>,
       <x^-1*t^-2*h^2*a,  [ 0, 1]>,
       
       <t^3*h^2*a,        [ 0, 1]>,
       <x*t^3*h^2*a,      [ 0, 1]>,
       <x^-1*t^3*h^2*a,   [ 0, 1]>,
       <t^-3*h^2*a,       [ 0, 1]>,
       <x*t^-3*h^2*a,     [ 0, 1]>,
       <x^-1*t^-3*h^2*a,  [ 0, 1]>]]);

print "";
print "<(1+3*sqrt(-7))/2>";

h:=t*a;

VerifyLink(
    Bianchi7, Bianchi7P,
    [[16,5,1]], 1536,
    [[ <Id(Bianchi7),            [-2, 5]>,
       <h,                       [-1, 3]>,
       <h^-1,                    [-1, 3]>,
       <t^-1*a,                  [-1, 2]>,
       <h*t^-1*a,                [-1, 3]>,
       <h^-1*t^-1*a,             [-1, 3]>,

       <t^-2*a,                  [-1, 3]>,
       <h*t^-2*a,                [-1, 3]>,
       <h^-1*t^-2*a,             [-1, 3]>,
       <t^3*a,                   [-1, 3]>,
       <h*t^3*a,                 [-1, 3]>,
       <h^-1*t^3*a,              [-1, 3]>,
       
       <t^-3*a,                  [-1, 3]>,
       <h*t^-3*a,                [-1, 3]>,
       <h^-1*t^-3*a,             [-1, 3]>,
       <t^4*a,                   [-1, 3]>,
       <h*t^4*a,                 [-1, 2]>,
       <h^-1*t^4*a,              [-1, 3]>,

       <t^-4*a,                  [-1, 3]>,
       <h*t^-4*a,                [-1, 3]>,
       <h^-1*t^-4*a,             [-1, 3]>,
       <t^5*a,                   [-1, 3]>,
       <h*t^5*a,                 [-1, 3]>,
       <h^-1*t^5*a,              [-1, 3]>,
       

       <t^-5*a,                  [-1, 3]>,
       <h*t^-5*a,                [-1, 3]>,
       <h^-1*t^-5*a,             [-1, 3]>,
       <t^6*a,                   [-1, 3]>,
       <h*t^6*a,                 [-1, 3]>,
       <h^-1*t^6*a,              [-1, 3]>,
       
       <t^-6*a,                  [-1, 3]>,
       <h*t^-6*a,                [-1, 3]>,
       <h^-1*t^-6*a,             [-1, 3]>,
       <t^7*a,                   [-1, 3]>,
       <h*t^7*a,                 [-1, 3]>,
       <h^-1*t^7*a,              [-1, 3]>,
       
       <t^-7*a,                  [-1, 3]>,
       <h*t^-7*a,                [-1, 3]>,
       <h^-1*t^-7*a,             [-1, 3]>,
       <t^8*a,                   [-1, 3]>,
       <h*t^8*a,                 [-1, 3]>,
       <h^-1*t^8*a,              [-1, 3]>,

       <t^-1*a*t^2*a,            [-1, 3]>,
       <h*t^-1*a*t^2*a,          [-1, 3]>,
       <h^-1*t^-1*a*t^2*a,       [-1, 3]>,
       <t^-2*a*t^2*a,            [-1, 3]>,
       <h*t^-2*a*t^2*a,          [-1, 3]>,
       <h^-1*t^-2*a*t^2*a,       [-1, 3]>,


       <t^3*a*t^-2*a,            [-1, 3]>,
       <h*t^3*a*t^-2*a,          [-1, 3]>,
       <h^-1*t^3*a*t^-2*a,       [-1, 3]>,
       <t^-3*a*t^2*a,            [-1, 3]>,
       <h*t^-3*a*t^2*a,          [-1, 3]>,
       <h^-1*t^-3*a*t^2*a,       [-1, 3]>,

       <t^-1*a*t^-3*a,           [-1, 3]>,
       <h*t^-1*a*t^-3*a,         [-1, 3]>,
       <h^-1*t^-1*a*t^-3*a,      [-1, 3]>,
       <t^-1*a*t^3*a,            [-1, 3]>,
       <h*t^-1*a*t^3*a,          [-1, 3]>,
       <h^-1*t^-1*a*t^3*a,       [-1, 3]>,
       
       <t^-2*a*t^-3*a,           [-1, 3]>,
       <h*t^-2*a*t^-3*a,         [-1, 3]>,
       <h^-1*t^-2*a*t^-3*a,      [-1, 3]>,
       <t^2*a*t^-3*a,            [-1, 3]>,
       <h*t^2*a*t^-3*a,          [-1, 3]>,
       <h^-1*t^2*a*t^-3*a,       [-1, 3]>,

       <t^-2*a*t^3*a,            [-1, 3]>,
       <h*t^-2*a*t^3*a,          [-1, 3]>,
       <h^-1*t^-2*a*t^3*a,       [-1, 3]>,
       <t^3*a*t^3*a,             [-1, 3]>,
       <h*t^3*a*t^3*a,           [-1, 3]>,
       <h^-1*t^3*a*t^3*a,        [-1, 3]>,

       
       <t^3*a*t^-3*a,            [-1, 3]>,
       <h*t^3*a*t^-3*a,          [-1, 3]>,
       <h^-1*t^3*a*t^-3*a,       [-1, 3]>,
       <t^-3*a*t^3*a,            [-1, 3]>,
       <h*t^-3*a*t^3*a,          [-1, 3]>,
       <h^-1*t^-3*a*t^3*a,       [-1, 3]>,
       
       <t^-4*a*t^3*a,            [-1, 3]>,
       <h*t^-4*a*t^3*a,          [-1, 3]>,
       <h^-1*t^-4*a*t^3*a,       [-1, 3]>,
       <t^-1*a*t^4*a,            [-1, 3]>,
       <h*t^-1*a*t^4*a,          [-1, 3]>,
       <h^-1*t^-1*a*t^4*a,       [-1, 3]>,
       
       <t^-2*a*t^-4*a,           [-1, 3]>,
       <h*t^-2*a*t^-4*a,         [-1, 3]>,
       <h^-1*t^-2*a*t^-4*a,      [-1, 3]>,
       <t^-1*a*t^5*a,            [-2, 5]>,
       <h*t^-1*a*t^5*a,          [-1, 3]>,
       <h^-1*t^-1*a*t^5*a,       [-1, 3]>,
       
       <t^-2*a*t^5*a,            [-1, 3]>,
       <h*t^-2*a*t^5*a,          [-2, 5]>,
       <h^-1*t^-2*a*t^5*a,       [-1, 3]>,
       <t^2*a*t^-3*a*t^2*a,      [-1, 3]>,
       <h*t^2*a*t^-3*a*t^2*a,    [-1, 3]>,
       <h^-1*t^2*a*t^-3*a*t^2*a, [-2, 5]>]]);
