from checkMatricesAndPeripheralsHelpers import *

Q = QuadraticField(-15)
psi = Q.gen()
w = (1+psi)/2

a = matrix(Q,[[ 0,-1],[ 1, 0]])
t = matrix(Q,[[ 1, 1],[ 0, 1]])
u = matrix(Q,[[ 1, w],[ 0, 1]])
c = matrix(Q,[[ 4,1-2*w],[2*w-1, 4]])

P = [[t,u],[u*c*a, c**-1 * a * u**-1 * c**-1 * u**-1 * t * a]]

# Check that we didn't do any mistakes typing in the matrices or
# peripheral elements by checking against the relations and checking
# that the given matrices for P are parabolic.
ensurePslMatricesAreIdentity([Com(t,u),Com(a,c),
                              a**2,(t*a)**3,u*c*u*a*t*u**-1*c**-1*u**-1*a*t**-1])
ensurePslMatricesAreParabolic(P)

print areNklTriplesValid(P,[[ 2, 0, 1], [ 1, 0, 2]], Q.ideal([ 2, ( 1+psi)/2]))
print areNklTriplesValid(P,[[ 3, 1, 1], [ 3, 0, 1]], Q.ideal([ 3, ( 3+psi)/2]))
print areNklTriplesValid(P,[[ 4, 0, 1], [ 1, 0, 4]], Q.ideal([    ( 1+psi)/2]))
print areNklTriplesValid(P,[[ 2, 0, 2], [ 2, 0, 2]], Q.ideal([ 2]))
print areNklTriplesValid(P,[[ 5, 2, 1], [ 5, 0, 1]], Q.ideal([ 5, ( 5+psi)/2]))
print areNklTriplesValid(P,[[ 6,-2, 1], [ 3, 0, 2]], Q.ideal([    ( 3-psi)/2]))
print areNklTriplesValid(P,[[ 8, 4, 1], [ 2, 1, 4]], Q.ideal([ 8, ( 9+psi)/2]))
print areNklTriplesValid(P,[[ 3, 0, 3], [ 3, 0, 3]], Q.ideal([ 3]))
print areNklTriplesValid(P,[[10, 2, 1], [ 5, 0, 2]], Q.ideal([    ( 5+psi)/2]))
print areNklTriplesValid(P,[[12, 4, 1], [ 3, 0, 4]], Q.ideal([12, (15-psi)/2]))
print areNklTriplesValid(P,[[15, 7, 1], [15, 0, 1]], Q.ideal([        psi]))
print areNklTriplesValid(P,[[17, 5, 1], [17,-8, 1]], Q.ideal([17, (23-psi)/2]))
print areNklTriplesValid(P,[[19,10, 1], [19, 4, 1]], Q.ideal([      2+psi]))
print areNklTriplesValid(P,[[ 5, 0, 5], [ 5, 0, 5]], Q.ideal([ 5]))
print areNklTriplesValid(P,[[31,-14,1], [31,13, 1]], Q.ideal([      4+psi]))

