from checkMatricesAndPeripheralsHelpers import *

Q = QuadraticField(-23)
psi = Q.gen()
w = (1+psi)/2

g1 = matrix(Q, [[ 1,-1+w],[ 0, 1]])
g2 = matrix(Q, [[ 1, 1], [ 0, 1]])
g3 = matrix(Q, [[ 0, 1], [-1, 1]])
g4 = matrix(Q, [[3+w, -4+w], [-2+w, -1-w]])
g5 = matrix(Q, [[5-w, 1+2*w], [2+w, -3+w]])

P = [[g2, g1], [g4, g5], [g4*g3*g2, g2**-1 *g5*g3*g2]]

# Check that we didn't do any mistakes typing in the matrices or
# peripheral elements by checking against the relations and checking
# that the given matrices for P are parabolic.
ensurePslMatricesAreIdentity([
        g3**3,(g3*g2)**2,Com(g1,g2),Com(g4,g5),
        g5*g2**-1*g3**-1*g5**-1*g1**-1*g2**-1*g3**-1*g1,
        g4**-1*g5*g3*g2*g5**-1*g2*g4*g3])
ensurePslMatricesAreParabolic(P)

print areNklTriplesValid(P,[[2,1,1],[1,0,2],[2,1,1]],    Q.ideal([ 2, ( 1+psi)/2]))
print areNklTriplesValid(P,[[3,1,1],[3,1,1],[3,0,1]],    Q.ideal([ 3, ( 1+psi)/2]))
print areNklTriplesValid(P,[[4,1,-1],[2,1,-2],[4,-1,1]], Q.ideal([ 4, ( 3-psi)/2]))
print areNklTriplesValid(P,[[2,0,2],[2,0,2],[2,0,2]],    Q.ideal([ 2]))
print areNklTriplesValid(P,[[6,1,1],[3,-1,2],[6,-3,1]],  Q.ideal([    ( 1+psi)/2]))
print areNklTriplesValid(P,[[6,-2,1],[6,1,1],[3,0,2]],   Q.ideal([ 6, ( 5-psi)/2]))
print areNklTriplesValid(P,[[8,-1,1],[4,1,2],[8,3,1]],   Q.ideal([    ( 3-psi)/2]))
print areNklTriplesValid(P,[[3,0,3],[3,0,3],[3,0,3]],    Q.ideal([ 3]))
print areNklTriplesValid(P,[[9,4,1],[9,-2,1],[9,6,1]],   Q.ideal([ 9, ( 7+psi)/2]))
print areNklTriplesValid(P,[[12,3,1],[6,3,2],[12,7,1]],  Q.ideal([    ( 5+psi)/2]))
print areNklTriplesValid(P,[[13,5,1],[13,4,1],[13,2,1]], Q.ideal([13, ( 9+psi)/2]))
print areNklTriplesValid(P,[[23,-11,1],[23,-6,1],[23,-6,1]], Q.ideal([psi]))
print areNklTriplesValid(P,[[5,0,5],[5,0,5],[5,0,5]],    Q.ideal([ 5]))
