from checkMatricesAndPeripheralsHelpers import *

Q = QuadraticField(-31)
psi = Q.gen()
w = (1+psi)/2

g1 = matrix(Q, [[ 1,-1], [ 0, 1]])
g2 = matrix(Q, [[ 0, 1], [-1, 1]])
g3 = matrix(Q, [[ 1, w], [ 0, 1]])
g4 = matrix(Q, [[ 3, -2+2*w], [ w, -5]])
g5 = matrix(Q, [[ 3-2*w, 7+w], [ 4, -1+2*w]])

P = [ [ g1, g3 ],
      [ g4, g5 ],
      [ g1*g5, g3**-1 *g2*g3* g4**-1 *g2*g5 ]]

# Check that we didn't do any mistakes typing in the matrices or
# peripheral elements by checking against the relations and checking
# that the given matrices for P are parabolic.
ensurePslMatricesAreIdentity([
        Com(g1,g3),(g2)**3,(g2*g1**-1)**2,Com(g5,g4),
        g4*g1**-1*g3**-1*g2*g3*g4**-1*g2*g4*g3**-1*g1**-1*g2*g3*g4**-1*g2,
        g5*g3**-1*g2*g3*g4**-1*g2*g1**-1*g5**-1*g2**-1*g4*g3**-1*g2**-1*g3*g1,
        g2*g3*g4**-1*g2*g1**-1*g4*g3**-1*g2*g3*g4**-1*g1*g2**-1*g4*g3**-1])
ensurePslMatricesAreParabolic(P)

print areNklTriplesValid(P,[[2,0,1],[1,0,2],[1,0,2]],      Q.ideal([ 2, ( 1+psi)/2]))
print areNklTriplesValid(P,[[4,0,1],[2,1,2],[1,0,4]],      Q.ideal([ 4, ( 1+psi)/2]))
print areNklTriplesValid(P,[[2,0,2],[2,0,2],[2,0,2]],      Q.ideal([ 2 ]))
print areNklTriplesValid(P,[[5,-1,1],[5,1,1],[5,1,1]],     Q.ideal([ 5, ( 3+psi)/2]))
print areNklTriplesValid(P,[[7,-2,1],[7,-2,1],[7,0,1]],    Q.ideal([ 7, ( 5+psi)/2]))
print areNklTriplesValid(P,[[8,0,1],[4,1,2],[2,-1,4]],     Q.ideal([    ( 1+psi)/2]))
print areNklTriplesValid(P,[[3,0,3],[3,0,3],[3,0,3]],      Q.ideal([ 3 ]))
print areNklTriplesValid(P,[[10,-1,1],[10,-4,1],[10,1,1]], Q.ideal([    ( 3+psi)/2]))
print areNklTriplesValid(P,[[10,-3,1],[10,2,1],[10,3,1]],  Q.ideal([10, ( 7+psi)/2]))
print areNklTriplesValid(P,[[19,5,-1],[19,3,1],[19,7,1]],  Q.ideal([19, (11+psi)/2]))
print areNklTriplesValid(P,[[5,0,5],[5,0,5],[5,0,5]],      Q.ideal([ 5]))
print areNklTriplesValid(P,[[31,16,1],[31,8,1],[31,5,-1]], Q.ideal([psi]))


