from checkMatricesAndPeripheralsHelpers import *

Q = QuadraticField(-47)
psi = Q.gen()
w = (1+psi)/2

g1 = matrix(Q, [[ -1, 1], [-1, 0]])
g2 = matrix(Q, [[ 1, 1], [ 0, 1]])
g3 = matrix(Q, [[ 1, -1+w], [0, 1]])
g4 = matrix(Q, [[-2+w, 5], [-3, 1+w]])
g5 = matrix(Q, [[ 5, -3+3*w], [w,-7]])
g6 = matrix(Q, [[ -4+w, 3+w], [-3-w, -4+w]])
g7 = matrix(Q, [[ 1-2*w, 11+w], [4, -3+2*w]])

P = [ [ g2, g3 ],
      [ g5, g7 ],
      [ g2*g7, g4* g1**-1 * g4**-1 *g5 ],
      [ g6* g2**-1 * g4**-1, g5* g3**-1 * g2**-1 * g4**-1 ],
      [ g6**-1 * g1**-1 *g4, g3* g5**-1 *g4*g1 ]]

# Check that we didn't do any mistakes typing in the matrices or
# peripheral elements by checking against the relations and checking
# that the given matrices for P are parabolic.
ensurePslMatricesAreIdentity([
        g1**3,Com(g3,g2),(g2**-1*g1)**2,Com(g5,g7),g2**-1*g1*g6*g1**-1*g2*g6**-1,
        g6*g2**-1*g4**-1*g5*g3**-1*g6**-1*g4*g2*g3*g5**-1,
        g7**-1*g2**-1*g5**-1*g4*g1*g4**-1*g2*g7*g4*g1**-1*g4**-1*g5,
        g3*g5**-1*g4*g1*g4**-1*g2*g5*g3**-1*g2**-1*g4**-1*g1**-1*g4,
        g5**-1*g4*g1*g4**-1*g7**-1*g2**-1*g4*g1**-1*g4**-1*g5*g3**-1*g2*g3*g7])
ensurePslMatricesAreParabolic(P)

print areNklTriplesValid(P,[[2,1,1], [2,1,1], [1,0,2], [1,0,2], [2,0,1]],
                     Q.ideal([2, (1+psi)/2]))
print areNklTriplesValid(P,[[3,1,1], [1,0,3], [3,1,-1], [1,0,3], [3,1,1]],
                     Q.ideal([3, (1+psi)/2]))
print areNklTriplesValid(P,[[4,1,1], [4,1,1], [1,0,4], [2,1,2], [4,2,1]],
                     Q.ideal([4, (1+psi)/2]))
print areNklTriplesValid(P,[[2,0,2], [2,0,2], [2,0,2], [2,0,2], [2,0,2]],
                     Q.ideal([2]))
print areNklTriplesValid(P,[[6,1,1], [2,1,3], [3,1,2], [1,0,6], [6,-2,1]],
                     Q.ideal([6, (1+psi)/2]))
print areNklTriplesValid(P,[[6,3,1], [6,-1,1], [3,0,2], [3,1,-2], [2,0,3]],
                     Q.ideal([6, (5+psi)/2]))
print areNklTriplesValid(P,[[7,2,1], [7,-3,1], [7,3,1], [7,2,1], [7,-1,1]],
                     Q.ideal([7, (3+psi)/2]))
print areNklTriplesValid(P,[[8,-3,1], [8,1,1], [2,-1,4], [4,1,2], [8,-2,1]],
                     Q.ideal([8, (7-psi)/2]))
print areNklTriplesValid(P,[[3,0,3], [3,0,3], [3,0,3], [3,0,3], [3,0,3]],
                     Q.ideal([3]))
print areNklTriplesValid(P,[[9,3,1], [9,2,1], [9,-3,1], [9,1,1], [3,1,3]],
                     Q.ideal([9, (5+psi)/2]))
print areNklTriplesValid(P,[[5,0,5], [5,0,5], [5,0,5], [5,0,5], [5,0,5]],
                     Q.ideal([5]))
