from snappy import Manifold

import sys, os

from trigUtils import *

usage = """Usage: python geometrizeSnapPyTriangulation.py TRIANGULATION.tri
   or: sage -python geometrizeSnapPyTriangulation.py TRIANGULATION.tri

Open SnapPy triangulation, tries to find a geometric solution and saves it
under the same file name.
"""

if __name__ == '__main__':
    if len(sys.argv) != 2:
        print usage
        sys.exit(1)

    with TimingMeasurement("total"):
        with TimingMeasurement("reading SnapPy triangulation"):
            T = Manifold(sys.argv[1])
            
        with TimingMeasurement("finding geometric solution"):
            while not 'posi' in T.solution_type():
                print "Randomizing"
                T.randomize()
                
        with TimingMeasurement("saving SnapPy triangulation"):
            T.save(sys.argv[1])
