

_formatReginaStatisticsStr = """eulerCharTri:            %d
eulerCharManifold:       %d
countBoundaryComponents: %d
countVertices:           %d
countTetrahedra:         %d
"""

def formatReginaStatistics(T):
    """
    Gives a string containing some information about the
    regina triangulation.
    """

    return _formatReginaStatisticsStr % (
        T.eulerCharTri(),
        T.eulerCharManifold(),
        T.countBoundaryComponents(),
        T.countVertices(),
        T.countTetrahedra())

_formatSnapPyStatisticsStr = """countBoundaryComponents: %s
countTetrahedra:         %d
"""

def formatSnapPyStatistics(T):
    return _formatSnapPyStatisticsStr % (
        T.num_cusps(),
        T.num_tetrahedra())
    
_formatHomologyStr = """betti: %d
torsion %r

"""

def formatHomology(H):
    """
    Takes the result from snappy.Triangulation.homology() and
    turns it into a string showing the rank of the free part and the
    torsion part.
    """

    return _formatHomologyStr % (
        H.betti_number(),
        [ c for c in H.coefficients if c ])

